<?php
/**
 * License
 *
 * @author    MagneticOne
 *
 * @copyright MagneticOne
 *
 * @license   MagneticOne
 */

if (!defined('_PS_VERSION_'))
  exit;

include_once(dirname(__FILE__).'/lib/auth.php');

class Cart2cartPasswords extends Module
{
  protected $_auth;
	public function __construct()
	{
		$this->name = 'cart2cartpasswords';
		$this->tab = 'migration_tools';
		$this->version = '1.0.0';
		$this->author = 'Cart2Cart';
		$this->need_instance = 0;
		$this->confirmUninstall = $this->l('');

		parent::__construct();

		$this->displayName = $this->l('Cart2Cart passwords');
		$this->description = $this->l('Allows you to use the Cart2Cart service to migrate users passwords.');

		$this->_auth = new Auth;
	}

	public function install()
	{
    parent::install();
    $isNewVersion = version_compare(_PS_VERSION_, '1.7.0.0') != -1;
    $hookName = $isNewVersion ? 'actionAuthenticationBefore' : 'ActionBeforeAuthentication';
    $this->registerHook($hookName);
    return true;
	}

	public function hookActionBeforeAuthentication()
	{
    $email = trim(Tools::getValue('email'));
    $passwd = trim(Tools::getValue('passwd')) ?: trim(Tools::getValue('password'));
    $customer = new Customer();
    $is8Version = version_compare(_PS_VERSION_, '8.0.0', '>=');

	  if (!empty($email) && Validate::isEmail($email) && !empty($passwd) && ((!$is8Version && !Validate::isPasswd($passwd)) || !$customer->getByEmail($email, $passwd))) {

      if ($customer->getByEmail($email)) {
        $rows = (array)Db::getInstance()->executeS('
          SELECT
            *
          FROM `'._DB_PREFIX_.'c2c_data`
          WHERE `id_customer` = '.(int)$customer->id.'
          GROUP BY id_customer
          ORDER BY id DESC
        ');

        if ($row = array_pop($rows)) {

          if ($this->_auth->customValidateHash($row['password_hash'], $passwd, $row['password_salt'])) {

            Db::getInstance()->execute('
              UPDATE `'._DB_PREFIX_.'customer`
              SET passwd = "'.Tools::encrypt($passwd).'", last_passwd_gen = "'.date('Y-m-d H:i:s', time() - 21600).'"
              WHERE `id_customer` = '.(int)$customer->id
            );

            Db::getInstance()->execute('
              DELETE
              FROM `'._DB_PREFIX_.'c2c_data`
              WHERE `id_customer` = '.(int)$customer->id
            );
          }
        }
      }
    }
  }

  public function hookActionAuthenticationBefore()
  {
    $this->hookActionBeforeAuthentication();
  }

  public function getContent()
  {

  }
}